/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.orchestra;

import java.util.HashMap;
import java.util.Map;

import org.objectweb.petals.component.common.bc.AbstractBindingComponent;
import org.objectweb.petals.component.common.bc.ExternalListenerManager;
import org.objectweb.petals.component.common.bc.JBIListener;
import org.objectweb.petals.component.common.su.ServiceUnitListener;
import org.objectweb.petals.engine.orchestra.incoming.JMSConnection;
import org.objectweb.petals.engine.orchestra.incoming.OrchestraExternalListenerManager;
import org.objectweb.petals.engine.orchestra.outgoing.OrchestraJBIListener;
import org.objectweb.petals.engine.orchestra.su.OrchestraServiceUnitListener;

/**
 * The orchestra JBI component.
 * 
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
public class OrchestraBC extends AbstractBindingComponent {

    Map<String, JMSConnection> jmsConsumerConnections = new HashMap<String, JMSConnection>();

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.component.common.se.AbstractServiceEngine#init(javax.jbi.component.ComponentContext)
     */
    @Override
    public void init(BindingComponentInitializer initializer) {

        jmsConsumerConnections = new HashMap<String, JMSConnection>();

        // create SU listener
        ServiceUnitListener suListener = new OrchestraServiceUnitListener(jmsConsumerConnections, getLogger());
        setServiceUnitListener(suListener);

        // create the listeners
        JBIListener listener = new OrchestraJBIListener(getLogger());
        ExternalListenerManager externalListener = new OrchestraExternalListenerManager(
            this, jmsConsumerConnections);

        initializer.setExternalListenerManager(externalListener);
        initializer.setJbiListener(listener);
    }

}
