/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.orchestra.util;

import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;

import javax.xml.transform.stream.StreamSource;

/**
 * 
 * @author Christophe HAMERLING - eBMWebSourcing
 *
 */
public class BytesSource extends StreamSource {
    
    private byte[] data;

    /**
     * Creates a new instance of {@link BytesSource}
     *
     * @param data
     */
    public BytesSource(byte[] data) {
        this.data = data;
    }

    /**
     * Creates a new instance of {@link BytesSource}
     *
     * @param data
     * @param systemId
     */
    public BytesSource(byte[] data, String systemId) {
        this.data = data;
        setSystemId(systemId);
    }

    /*
     * (non-Javadoc)
     * @see javax.xml.transform.stream.StreamSource#getInputStream()
     */
    public InputStream getInputStream() {
        return new ByteArrayInputStream(data);
    }

    /*
     * (non-Javadoc)
     * @see javax.xml.transform.stream.StreamSource#getReader()
     */
    public Reader getReader() {
        return new InputStreamReader(getInputStream());
    }

    /**
     * 
     * @return
     */
    public byte[] getData() {
        return data;
    }

    /*
     * (non-Javadoc)
     * @see java.lang.Object#toString()
     */
    public String toString() {
        return "BytesSource[" + new String(data) + "]";
    }

}
