/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.engine.orchestra.util;

import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPEnvelope;

import org.w3c.dom.Attr;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

/**
 * 
 * @author Christophe HAMERLING - eBMWebSourcing
 *
 */
public class OrchestraUtil {

    /**
     * 
     * @param el
     * @return
     * @throws Exception
     */
    public static Element removeEnvelope(Element el) throws Exception {
        Element result = el;
        if (el instanceof SOAPEnvelope) {
            SOAPEnvelope env = (SOAPEnvelope) el;
            SOAPBody body = env.getBody();
            result = (Element) body.getChildElements().next();
            // addAttributes(env, result);
            // addAttributes(body, result);
        }
        return result;
    }

    /**
     * 
     * @param source
     * @param dest
     */
    public static void addAttributes(Node source, Element dest) {
        Document destDoc = dest.getOwnerDocument();
        NamedNodeMap destAttributes = dest.getAttributes();
        NamedNodeMap attributes = source.getAttributes();
        if (attributes != null) {
            for (int i = 0; i < attributes.getLength(); i++) {
                Node attr = attributes.item(i);
                String attrName = attr.getNodeName();
                if (attrName.startsWith("xmlns")) {
                    if (!containsAttribute(destAttributes, attrName)) {
                        Attr newAttr = destDoc.createAttribute(attrName);
                        newAttr.setValue(attr.getNodeValue());
                        dest.setAttributeNode(newAttr);
                    }
                }
            }
        }
    }

    /**
     * 
     * @param attributes
     * @param attrName
     * @return
     */
    public static boolean containsAttribute(NamedNodeMap attributes,
        String attrName) {
        if (attributes != null) {
            return attributes.getNamedItem(attrName) != null;
        }
        return false;
    }
}
