/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.airline;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.jws.WebService;

import org.objectweb.petals.demo.travelagency.airline.beans.AirlineBookingResultBean;
import org.objectweb.petals.demo.travelagency.airline.beans.AirlineTripBean;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
@WebService(endpointInterface = "org.objectweb.petals.demo.travelagency.airline.AirlineBookingWebService")
public class AirlineBookingWebServiceImpl implements AirlineBookingWebService {

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.demo.travelagency.airline.BookingWebService#bookFlight(java.lang.String,
     *      java.lang.String, java.lang.String, java.lang.String,
     *      java.lang.String, java.lang.String, java.lang.String)
     */
    public AirlineBookingResultBean bookFlight(String firstName,
        String lastName, String email, String from, String to,
        String departureDate, String returnDate) {

        SimpleDateFormat sdf = new SimpleDateFormat(
            "dd.MM.yyyy G 'at' HH:mm:ss z");

        System.out
            .println("----------------------------------------------------");
        System.out.println("Receiving a flight booking request...");
        System.out.println("Current time is "
            + sdf.format(new Date(System.currentTimeMillis())));
        System.out.println();
        System.out.println("First name     : " + firstName);
        System.out.println("Last name      : " + lastName);
        System.out.println("Email          : " + email);
        System.out.println("From city      : " + from);
        System.out.println("To city        : " + to);
        System.out.println("Departure date : " + departureDate);
        System.out.println("Return date    : " + returnDate);
        System.out.println();

        System.out.println("Booking process...");
        AirlineBookingResultBean result = new AirlineBookingResultBean(
            generateId(), firstName, lastName, createDepartureTripBean(from,
                to, departureDate), createReturnTripBean(to, from, returnDate));
        System.out.println("Booked !");

        System.out.println();
        System.out.println("##### Booking result #####");
        System.out.println();
        System.out.println("# Departure trip");
        System.out.println(result.getDepartureTrip().toString());
        System.out.println("# Return trip");
        System.out.println(result.getReturnTrip().toString());

        // TODO, register request in DB...

        return result;
    }

    /**
     * 
     * @return
     */
    private int generateId() {
        // TODO
        return 98798764;
    }

    /**
     * 
     * @param from
     * @param to
     * @param departureDate
     * @return
     */
    private AirlineTripBean createDepartureTripBean(String from, String to,
        String departureDate) {
        AirlineTripBean bean = new AirlineTripBean("AIRFANCE", "26F", "AF776",
            departureDate, "06:55", "15:45", from, to, 1200);
        // TODO
        return bean;
    }

    /**
     * 
     * @param from
     * @param to
     * @param returnDate
     * @return
     */
    private AirlineTripBean createReturnTripBean(String from, String to,
        String returnDate) {
        AirlineTripBean bean = new AirlineTripBean("KLM", "56A", "KLM002",
            returnDate, "12:55", "02:45", from, to, 955);
        // TODO
        return bean;
    }

}
