/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.airline.beans;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
public class AirlineBookingResultBean {

    private int id;

    private String firstName;

    private String lastName;

    private AirlineTripBean departureTrip;

    private AirlineTripBean returnTrip;
    
    /**
     * 
     * Creates a new instance of {@link AirlineBookingResultBean}
     *
     */
    public AirlineBookingResultBean() {
    }

    /**
     * Creates a new instance of {@link AirlineBookingResultBean}
     * 
     * @param departureTrip
     * @param returnTrip
     */
    public AirlineBookingResultBean(int id, String firstName, String lastName, AirlineTripBean departureTrip, AirlineTripBean returnTrip) {
        super();
        this.id = id;
        this.firstName = firstName;
        this.lastName = lastName;
        this.departureTrip = departureTrip;
        this.returnTrip = returnTrip;
    }

    /**
     * @return the departureTrip
     */
    public AirlineTripBean getDepartureTrip() {
        return departureTrip;
    }

    /**
     * @param departureTrip
     *            the departureTrip to set
     */
    public void setDepartureTrip(AirlineTripBean departureTrip) {
        this.departureTrip = departureTrip;
    }

    /**
     * @return the returnTrip
     */
    public AirlineTripBean getReturnTrip() {
        return returnTrip;
    }

    /**
     * @param returnTrip
     *            the returnTrip to set
     */
    public void setReturnTrip(AirlineTripBean returnTrip) {
        this.returnTrip = returnTrip;
    }

    /**
     * @return the id
     */
    public int getId() {
        return id;
    }

    /**
     * @param id
     *            the id to set
     */
    public void setId(int id) {
        this.id = id;
    }

    /**
     * @return the firstName
     */
    public String getFirstName() {
        return firstName;
    }

    /**
     * @param firstName the firstName to set
     */
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    /**
     * @return the lastName
     */
    public String getLastName() {
        return lastName;
    }

    /**
     * @param lastName the lastName to set
     */
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }
}
