/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.airline.beans;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
public class AirlineTripBean {
    private String compagny;

    private String seatNb;

    private String flightNb;

    private String date;

    private String departureHour;

    private String arrivalHour;

    private String fromCity;

    private String toCity;

    private int price;

    /**
     * 
     * Creates a new instance of {@link AirlineTripBean}
     * 
     */
    public AirlineTripBean() {
    }

    /**
     * Creates a new instance of {@link AirlineTripBean}
     * 
     * @param compagny
     * @param seatNb
     * @param flightNb
     * @param date
     * @param departureHour
     * @param arrivalHour
     * @param fromCity
     * @param toCity
     * @param price
     */
    public AirlineTripBean(String compagny, String seatNb, String flightNb,
        String date, String departureHour, String arrivalHour, String fromCity,
        String toCity, int price) {
        super();
        this.compagny = compagny;
        this.seatNb = seatNb;
        this.flightNb = flightNb;
        this.date = date;
        this.departureHour = departureHour;
        this.arrivalHour = arrivalHour;
        this.fromCity = fromCity;
        this.toCity = toCity;
        this.price = price;
    }

    /**
     * @return the arrivalHour
     */
    public String getArrivalHour() {
        return arrivalHour;
    }

    /**
     * @param arrivalHour
     *            the arrivalHour to set
     */
    public void setArrivalHour(String arrivalHour) {
        this.arrivalHour = arrivalHour;
    }

    /**
     * @return the compagny
     */
    public String getCompagny() {
        return compagny;
    }

    /**
     * @param compagny
     *            the compagny to set
     */
    public void setCompagny(String compagny) {
        this.compagny = compagny;
    }

    /**
     * @return the date
     */
    public String getDate() {
        return date;
    }

    /**
     * @param date
     *            the date to set
     */
    public void setDate(String date) {
        this.date = date;
    }

    /**
     * @return the departureHour
     */
    public String getDepartureHour() {
        return departureHour;
    }

    /**
     * @param departureHour
     *            the departureHour to set
     */
    public void setDepartureHour(String departureHour) {
        this.departureHour = departureHour;
    }

    /**
     * @return the flightNb
     */
    public String getFlightNb() {
        return flightNb;
    }

    /**
     * @param flightNb
     *            the flightNb to set
     */
    public void setFlightNb(String flightNb) {
        this.flightNb = flightNb;
    }

    /**
     * @return the fromCity
     */
    public String getFromCity() {
        return fromCity;
    }

    /**
     * @param fromCity
     *            the fromCity to set
     */
    public void setFromCity(String fromCity) {
        this.fromCity = fromCity;
    }

    /**
     * @return the price
     */
    public int getPrice() {
        return price;
    }

    /**
     * @param price
     *            the price to set
     */
    public void setPrice(int price) {
        this.price = price;
    }

    /**
     * @return the seatNb
     */
    public String getSeatNb() {
        return seatNb;
    }

    /**
     * @param seatNb
     *            the seatNb to set
     */
    public void setSeatNb(String seatNb) {
        this.seatNb = seatNb;
    }

    /**
     * @return the toCity
     */
    public String getToCity() {
        return toCity;
    }

    /**
     * @param toCity
     *            the toCity to set
     */
    public void setToCity(String toCity) {
        this.toCity = toCity;
    }

    public String toString() {
        StringBuffer sb = new StringBuffer();
        sb.append("Company : ");
        sb.append(compagny);
        sb.append("\n");
        sb.append("Seat : ");
        sb.append(seatNb);
        sb.append("\n");
        sb.append("Flight : ");
        sb.append(flightNb);
        sb.append("\n");
        sb.append("Date : ");
        sb.append(date);
        sb.append("\n");
        sb.append("Departure Hour : ");
        sb.append(departureHour);
        sb.append("\n");
        sb.append("Arrival Hour : ");
        sb.append(arrivalHour);
        sb.append("\n");
        sb.append("From city : ");
        sb.append(fromCity);
        sb.append("\n");
        sb.append("To city : ");
        sb.append(toCity);
        sb.append("\n");
        sb.append("Price : $");
        sb.append(price);
        sb.append("\n");

        return sb.toString();
    }
}
