#!/bin/sh

echo "**************************************"
echo "*                                    *"
echo "*          TRAVEL AGENCY DEMO        *"
echo "*                                    *"
echo "**************************************"
echo ""


if [ -z "$TOMCAT_HOME" ] ; then
  echo "TOMCAT_HOME is not set"
  exit 1
fi

echo "1. Copy the WebClient and the Airline WebServices WAR in $TOMCAT_HOME/webappss" 
cp ../applications/*.war $TOMCAT_HOME/webapps

echo "2. Start the WebClient and the Airline WebServices on TOMCAT"
$TOMCAT_HOME/bin/startup.sh &
echo "3. Open the TOMCAT logs in a new window"
xterm -T "Airline WebServices" -bg blue -fg white -hold  -e "tail -f $TOMCAT_HOME/logs/catalina.out" &

echo "4. Start Hotel JMS Services on JORAM"
xterm -hold -e "java -jar ../applications/petals-travelagency-hotel-1.2-M1-SNAPSHOT.jar" &
cd ..

echo "5. Launch WebNavigator"
firefox http://localhost:8080/TravelAgency &

echo "6. Open the FileTransfer repository"
xterm -T "FileTransfer repository" -bg blue -fg white &

echo "7. Open a PEtALS shell "
xterm -T "PEtALS ServicePlatform" -bg purple -fg white &

echo "...Externals applications are started."
echo "8. To complete the demo, :"
echo "   - Launch PEtALS" 
echo "   - Install the following components:"
echo "       - PEtALS SOAP Binding Component"
echo "       - PEtALS JMS Binding Component"
echo "       - PEtALS FileTransfer Binding Component"
echo "       - travelagency/jbi/components/workflow Service Engine"
echo "   - Deploy the ServiceAssemblies contained in travelagency/serviceAssemblies"
