/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.hotel;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.objectweb.petals.demo.travelagency.hotel.beans.HotelBookingRequestBean;
import org.objectweb.petals.demo.travelagency.hotel.beans.HotelBookingResultBean;
import org.objectweb.petals.demo.travelagency.hotel.beans.HotelInfoBean;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
public class HotelBookingServiceImpl implements HotelBookingService {

    /**
     * Creates a new instance of {@link HotelBookingServiceImpl}
     * 
     * @param firstName
     * @param lastName
     * @param city
     * @param arrivalDate
     * @param departureDate
     */
    public HotelBookingServiceImpl() {
        super();
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.objectweb.petals.demo.travelagency.hotel.HotelBookingService#bookHotel(java.lang.String,
     *      java.lang.String, java.lang.String, java.lang.String,
     *      java.lang.String)
     */
    public HotelBookingResultBean bookHotel(HotelBookingRequestBean request) {

        HotelInfoBean hotel = getHotel(request.getCity(), request.getCheckIn(),
            request.getCheckOut());
        int nbNights = getnbNights(request.getCheckIn(), request.getCheckOut());

        return new HotelBookingResultBean(request.getFirstName(), request
            .getLastName(), hotel, request.getCheckIn(), request.getCheckOut(),
            nbNights, nbNights * hotel.getNightPrice());
    }

    /**
     * 
     * @param city
     * @param checkIn
     * @param checkOut
     * @return
     */
    protected HotelInfoBean getHotel(String city, String checkIn,
        String checkOut) {
        // TODO
        HotelInfoBean hotel = new HotelInfoBean("Confort Inn", "555-4569654",
            "5th avenue", "", city, 120, "No description", 3);

        return hotel;
    }

    /**
     * 
     * @param checkIn
     * @param checkOut
     * @return
     */
    protected int getnbNights(String checkIn, String checkOut) {
        long result = 1;

        SimpleDateFormat sdf = new SimpleDateFormat("dd/MM/yyyy");
        try {
            Date checkInDate = sdf.parse(checkIn);
            Date checkOutDate = sdf.parse(checkOut);

            long diff = checkOutDate.getTime() - checkInDate.getTime();
            result = Math.round((diff / (1000 * 60 * 60 * 24)));

        } catch (ParseException e) {
        }
        return new Long(result).intValue();
    }
}
