/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.hotel.beans;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 *
 */
public class HotelBookingResultBean {
    
    private String firstName;
    
    private String lastName;
    
    private HotelInfoBean hotelInfo;
    
    private String checkIn;
    
    private String checkOut;
    
    private int nbNights;
    
    private int price;

    /**
     * Creates a new instance of {@link HotelBookingResultBean}
     *
     * @param firstName
     * @param lastName
     * @param hotelInfo
     * @param checkIn
     * @param checkOut
     * @param nbNights
     * @param price
     */
    public HotelBookingResultBean(String firstName, String lastName, HotelInfoBean hotelInfo, String checkIn, String checkOut, int nbNights, int price) {
        super();
        this.firstName = firstName;
        this.lastName = lastName;
        this.hotelInfo = hotelInfo;
        this.checkIn = checkIn;
        this.checkOut = checkOut;
        this.nbNights = nbNights;
        this.price = price;
    }

    /**
     * @return the arrivalDate
     */
    public String getCheckIn() {
        return checkIn;
    }

    /**
     * @param arrivalDate the arrivalDate to set
     */
    public void setCheckIn(String arrivalDate) {
        this.checkIn = arrivalDate;
    }

    /**
     * @return the departureDate
     */
    public String getCheckOut() {
        return checkOut;
    }

    /**
     * @param departureDate the departureDate to set
     */
    public void setCheckOut(String departureDate) {
        this.checkOut = departureDate;
    }

    /**
     * @return the firstName
     */
    public String getFirstName() {
        return firstName;
    }

    /**
     * @param firstName the firstName to set
     */
    public void setFirstName(String firstName) {
        this.firstName = firstName;
    }

    /**
     * @return the hotelInfo
     */
    public HotelInfoBean getHotelInfo() {
        return hotelInfo;
    }

    /**
     * @param hotelInfo the hotelInfo to set
     */
    public void setHotelInfo(HotelInfoBean hotelInfo) {
        this.hotelInfo = hotelInfo;
    }

    /**
     * @return the lastName
     */
    public String getLastName() {
        return lastName;
    }

    /**
     * @param lastName the lastName to set
     */
    public void setLastName(String lastName) {
        this.lastName = lastName;
    }

    /**
     * @return the nbNights
     */
    public int getNbNights() {
        return nbNights;
    }

    /**
     * @param nbNights the nbNights to set
     */
    public void setNbNights(int nbNights) {
        this.nbNights = nbNights;
    }

    /**
     * @return the price
     */
    public int getPrice() {
        return price;
    }

    /**
     * @param price the price to set
     */
    public void setPrice(int price) {
        this.price = price;
    }

}
