/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.demo.travelagency.hotel.jms;

import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueReceiver;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;

import org.objectweb.petals.demo.travelagency.hotel.gui.Console;

/**
 * @author Christophe HAMERLING - eBMWebSourcing
 * 
 */
public class Receiver extends Thread {
    static Context ictx = null;
    
    private boolean running = true;
    
    private Console console;
    
    /**
     * Creates a new instance of {@link Receiver}
     *
     */
    public Receiver() {
        console = new Console();
    }
    
    /*
     * (non-Javadoc)
     * @see java.lang.Thread#run()
     */
    public void run() {
        try {
            console.setVisible(true);
            console.logMessage("Creating message receiver...");

            ictx = new InitialContext();
            Queue queueRequest = (Queue) ictx.lookup(ClassicAdmin.QUEUE_REQUEST);
            QueueConnectionFactory qcf = (QueueConnectionFactory) ictx
                .lookup("qcf");
            ictx.close();

            QueueConnection qc = qcf.createQueueConnection();
            QueueSession qs = qc.createQueueSession(true, 0);
            QueueReceiver qrec = qs.createReceiver(queueRequest);
            qrec.setMessageListener(new MsgListener("Receiver", console));

            while (running) {
                qc.start();
                synchronized (this) {
                    wait(1000);
                }
            }
            console.logMessage("Stopping the message receiver...");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    /**
     * Stops the current thread
     *
     */
    public void stopListening() {
        this.running = false;
    }
}
