/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2006 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.objectweb.petals.engine.helloworld;

import java.util.logging.Level;
import java.util.logging.Logger;

import org.objectweb.petals.tools.jbicommon.util.StringHelper;

/**
 * The Helloworld service implementation
 *
 * @author eBM WebSourcing
 *
 */
public class HelloworldImpl implements Helloworld {

    public static final String HELLOWORLD_CONTEXT = "helloworldContext";

    public static final String HELLOWORLD_JNDI_ENTRY = "helloworldEntry";

    private Logger logger; // NOPMD

    /**
     * Creates a new instance of HelloworldImpl
     *
     * @param logger
     */
    public HelloworldImpl(Logger logger) {
        super();
        this.logger = logger;
    }

    /*
     * (non-Javadoc)
     *
     * @see org.objectweb.petals.engine.helloworld.Helloworld#printMessage(java.lang.String)
     */
    public void printMessage(final String message) {
        if (StringHelper.isNullOrEmpty(message)) {
            logger.log(Level.INFO, "hello.printNothing");
        } else {
            logger.log(Level.INFO, "hello.received", new String[] {message});
        }
    }

    /*
     * (non-Javadoc)
     *
     * @see org.objectweb.petals.engine.helloworld.Helloworld#sayHello(java.lang.String)
     */
    public String sayHello(final String message) {
        String response = "<response>You told me: " + message + "</response>";
        if (StringHelper.isNullOrEmpty(message)) {
            logger.log(Level.INFO, "hello.printNothing");
            response = "<response>You told me nothing</response>";
        } else {
            logger.log(Level.INFO, "hello.received", new String[] {message});
            response = "<response>You told me: " + message + "</response>";
        }
        return response;
    }
}
