<!--
/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -
 * $Id: component.jsp msauvage $
 * -
*/
-->
<%@ page language="java" contentType="text/html; charset=UTF-8"
	pageEncoding="UTF-8" session="true"%>
<%@page import="java.util.Date"%>
<%@page import="java.util.ListIterator"%>
<%@page import="java.util.List"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ServerConfiguration"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ExchangesList"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.MessageExchange"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.Message"%>
<jsp:useBean id="MonitorController" scope="session"
	class="org.objectweb.petals.tools.webadmin.controller.MonitorController"></jsp:useBean>
<jsp:useBean id="MathTools" scope="session"
	class="org.objectweb.petals.tools.webadmin.util.MathTools"></jsp:useBean>
<%
//get stored exchanges : a Map of <server name, server exchanges>
List<ServerConfiguration> startedServers = null;
if (session.getAttribute("startedServers")!=null)
{
	startedServers = (List<ServerConfiguration>) session.getAttribute("startedServers");
}

//no component called -> nothing to show
if(request.getParameter("compo")==null)
{
	%>
	<h1>&nbsp;</h1>
	<div id="msg_exch">
		&nbsp;
	</div>
	<%
}
else
{
	//retrieving requested informations
	String compo = request.getParameter("compo").toString();
	session.setAttribute("currentComponent",compo);
	//RETRIEVING SERVER'S INFO
	String serverName=new String();
	//get server's name wanted
	if(request.getParameter("serv")!=null)
	{
		serverName=request.getParameter("serv").toString();
	}
	//writing page title
	%>
	<h1><%=compo%> on server <%=serverName%></h1>
	<%
	
	//retrieving server's informations
	ServerConfiguration serverConf = null;
	//search for server's informations in started servers known
	boolean found = false;
	if (startedServers!=null && startedServers.size()>0)
	{
		ListIterator<ServerConfiguration> parcServers = startedServers.listIterator();
		while (!found && parcServers.hasNext())
		{
			ServerConfiguration currentServer = parcServers.next();
			if (currentServer.getName().equals(serverName))
			{
				serverConf=currentServer;
				session.setAttribute("currentServerConf",serverConf);
				found=true;
			}
		}
	}
	
	//if server not found -> nothing can be done
	if (!found)
	{
		%>
		<h2>Server Unavailable</h2>
		Reloading menu...
		<script type="text/javascript">
		openPage('menu.jsp','menu');
		</script>
		<%
	}
	else
	{
		try {
				%>
				<div id="utils">
					<a href="#" onclick="setInnerHTML(document.getElementById('content'),getFileContent('component.jsp?serv=<% out.print(serverName); %>&compo=<% out.print(compo); %>'));return false;" title="Refresh Content"><img src="img/refresh.png" alt="Refresh Content"/></a>
				</div>
				<div id="global-exch-infos">
				<h2>Exchanges in 10 last seconds</h2>
				<%
				long now = new Date().getTime();
				long startTime = now-10000;
				long timeElapsed=(now-startTime)/1000;
				ExchangesList lastExchanges=MonitorController.getExchanges(serverConf.getConnection(),startTime,compo);
				int nbExch = lastExchanges.size();
				double nbMsgSec = 0.00;
				if(nbExch>0)
				{
					nbMsgSec=MathTools.nb_per_sec(timeElapsed,nbExch);
				}
				//count of messages concerning the component only
				int nbCaps=0;
				for (MessageExchange currentExch : lastExchanges)
				{
					for (Message currentMsg : currentExch)
					{
						if (currentMsg.getComponent().equals(compo))
						{
							nbCaps++;
						}
					}
				}
				double nbCapsSec = 0.00;
				if (nbCaps > 0)
				{
					nbCapsSec=MathTools.nb_per_sec(timeElapsed,nbCaps);
				}
				%>
				<table>
				<tr><td>Exchanges : <%=nbExch%></td><td>Exchanges/sec : <%=nbMsgSec%></td></tr>
				<tr><td>Messages : <%=nbCaps%></td><td>Messages/sec : <%=nbCapsSec%></td></tr>
				</table>
				<h2>Exchanges in 10 last minutes</h2>
				<%
				now = new Date().getTime();
				startTime = now-10*60*1000;
				timeElapsed=(now-startTime)/1000;
				lastExchanges=MonitorController.getExchanges(serverConf.getConnection(),startTime,compo);
				nbExch = lastExchanges.size();
				nbMsgSec = MathTools.nb_per_sec(timeElapsed,nbExch);
				nbCaps=0;
				for (MessageExchange currentExch : lastExchanges)
				{
					for (Message currentMsg : currentExch)
					{
						if (currentMsg.getComponent().equals(compo))
						{
							nbCaps++;
						}
					}
				}
				nbCapsSec = 0.00;
				if (nbCaps > 0)
				{
					nbCapsSec = MathTools.nb_per_sec(timeElapsed,nbCaps);
				}
				%>
				<table>
				<tr><td>Exchanges : <%=nbExch%></td><td>Exchanges/sec : <%=nbMsgSec%></td></tr>
				<tr><td>Messages : <%=nbCaps%></td><td>Messages/sec : <%=nbCapsSec%></td></tr>
				</table>
				</div>
				<%
		}
		catch (Exception e)
		{
			if (serverConf==null)
			{
				%>
				<h1>Connection Error</h1>
				<p>Cannot connect to server<br />
				Maybe session is down, try to <a href="quit.jsp" title="Restart PEtALS Admin">reconnect</a>.</p>
				<%
			}
			else
			{
				%>
				<h2>EXCEPTION THROWN FOR <%=compo.toUpperCase()%> ON SERVER <%=serverName.toUpperCase()%></h2>
				<pre><strong>Class :</strong><br /><%=e.getClass()%></pre>
				<pre><strong>Message :</strong><br /><%=e.getMessage()%></pre>
				<pre><strong>Cause :</strong><br /><%=e.getCause() %></pre>
				<%
			}
		}
	}
}
%>
