/**
* invert the display attribute of an element to show or hide it.
* modify the picture corresponding 
* @param : id - id of the element concerned, img must have "img_<id>" for id
*/
function showHide(id)
{
	if(document.getElementById) {
		element = document.getElementById(id);
		img = document.getElementById('img_' + id);
	} else if(document.all) {
		element = document.all[id];
		img = document.all['img_' + id];
	} else return;
	
	if(element.style) {
		if(element.style.display == 'block' ) {
			element.style.display = 'none';
			img.src = 'img/plus.png';
		} else {
			element.style.display = 'block';
			img.src = 'img/minus.png';
		}
	}
}

/**
* show an element, modify the picture corresponding to "plus" image
* @param id : id of the element to show, picture must have "img_<id>" for id
*/
function show(id) {
	if(document.getElementById) {
		element = document.getElementById(id);
		img = document.getElementById('img_' + id);
	} else if(document.all) {
		element = document.all[id];
		img = document.all['img_' + id];
	} else return;
	
	if(element.style) {
		element.style.display = 'block';
		img.src = 'img/minus.png';
	}
}

/**
* hide an element, modify the picture corresponding to "minus" image
* @param id : id of the element to show, picture must have "img_<id>" for id
*/
function hide(id) {
	if(document.getElementById) {
		element = document.getElementById(id);
		img = document.getElementById('img_' + id);
	} else if(document.all) {
		element = document.all[id];
		img = document.all['img_' + id];
	} else return;
	
	if(element.style) {
		element.style.display = 'none';
		img.src = 'img/plus.png';
	}
}

function expandAll(id_parent) {
	var lists=document.getElementById(id_parent).getElementsByTagName('div');
	for(i=0;i!=lists.length;i++){
		var listId=lists[i].id;
		show(listId);
	}
}

function collapseAll(id_parent) {
	var lists=document.getElementById(id_parent).getElementsByTagName('div');
	for(i=0;i!=lists.length;i++){
		var listId=lists[i].id;
		hide(listId);
	}
}


/*
* change message in element id with msg
*/
function changeMsg(id,msg)
{
	setInnerHTML(document.getElementById(id),msg);
}


//refresh messages repartition chart
var timer_grMsg=null;
function refresh_grMsg()
{
	if(document.getElementById) {
		img = document.getElementById('graphMsg');
	} else if(document.all) {
		img = document.all['graphMsg'];
	} else return;
	if (img) {
		img.src='./graph/MsgRepartition?id='+Math.random();
	}
	else {
		clearInterval(timer_grMsg);
	}
}

//refresh messages per second chart
var timer_mps=null;
function refresh_mps()
{
	if(document.getElementById) {
		img = document.getElementById('graphMsgPerSec');
	} else if(document.all) {
		img = document.all['graphMsgPerSec'];
	} else return;
	if (img) {
		img.src='./graph/MsgPerSecond?id='+Math.random();
	}
	else {
		clearInterval(timer_mps);
	}
}

//refresh exchanges retrieval div
var timer_retr=null;
function refresh_retr()
{
	openPage('retrieve_exchanges.jsp','retr_exch');
}

