<!--
/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -
 * $Id: index.jsp msauvage $
 * -
*/
-->
<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8" session="true"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ServerConfiguration"%>
<%
//if there is already a session with a server configuration setted
//--> no need to login, going directly into webadmin
if (session.getAttribute("entryServerConf")!=null)
{
	%>
	<jsp:forward page="home.jsp"/>
	<%
}
//initializing variables
boolean serverReachable=false;
String host = "";
String jmxPort = "";
String jmxLogin = "";
String jmxPassword = "";
String errorMsg = null;
//if method received is POST (form validated)
if(request.getMethod()!=null && request.getMethod().equals("POST"))
{
	//getting parameters
	if (request.getParameter("host")!=null)
		host = request.getParameter("host");
	if (request.getParameter("jmxPort")!=null)
		jmxPort = request.getParameter("jmxPort");
	if (request.getParameter("jmxLogin")!=null)
		jmxLogin = request.getParameter("jmxLogin");
	if (request.getParameter("jmxPasswd")!=null)
		jmxPassword = request.getParameter("jmxPasswd");
	ServerConfiguration serverConf = new ServerConfiguration(host,jmxPort,jmxLogin,jmxPassword);
	serverReachable = JMXService.serverReachable(serverConf);
	if (serverReachable) //server asked is accessible
	{
		//retrieve name of the server via JMX call to it
		serverConf.setName();
		//server is active -> retrieve and set connection to it
		serverConf.setConnection();
		//setting entry server configuration in session
		session.setAttribute("entryServerConf",serverConf);
		//forwarding user to application
		%>
		<jsp:forward page="home.jsp"/>
		<%
	}
	else
	{
		//displaying information
		errorMsg="Server Unreachable";
	}
}
else
{
	//method received is GET (or other) 
	//-> initializing host and port to default for display in login form
	host="localhost";
	jmxPort="7700";
}
%>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%@page import="org.objectweb.petals.tools.webadmin.service.JMXService"%>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>PEtALS Administration</title>
<link rel="shortcut icon" type="image/x-icon" href="img/favicon.png" />
<link rel="stylesheet" href="includes/style.css" type="text/css" media="screen" />
<!--[if lte IE 6]>
	<link rel="stylesheet" type="text/css" href="includes/style-ie.css" media="screen" />
<![endif]-->
</head>
<body>
<div id="loginPage">

<h1>Welcome to PEtALS Administration</h1>
<div id="loginContent">
	<img id="logo" src="img/logo.png" alt="PEtALS"/>
		<div id="loginForm">
			<form id="form_login" method="post" action="index.jsp">
			<fieldset>
			<dl>
			<dt>Server Host :</dt><dd><input type="text" id="host" name="host" size="20" value="<%=host%>" /></dd>
			<dt>JMX Port :</dt><dd><input type="text" id="jmxPort" name="jmxPort" size="20" value="<%=jmxPort%>" /></dd>
			<dt>JMX User :</dt><dd><input type="text" id="jmxLogin" name="jmxLogin" size="20" value="<%=jmxLogin%>" /></dd>
			<dt>JMX Password :</dt><dd><input type="text" id="jmxPassword" name="jmxPassword" size="20" value="<%=jmxPassword%>" /></dd>
			<dt>&nbsp;</dt><dd class="center"><input type="submit" id="submitLogin" name="submitLogin" value="Connect" /></dd>
			</dl>
			</fieldset>
			</form>
		</div>
</div>
<%
//display error message if any
if (errorMsg!=null)
{
	%>
	<div id="loginError"><%=errorMsg%></div>
	<%
}
%>
</div>
</body>
</html>