<!--
/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -
 * $Id: messages_details.jsp msauvage $
 * -
*/
-->
<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8" session="true"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.MessageExchange"%>

<%@page import="org.objectweb.petals.tools.webadmin.Object.Message"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ExchangesList"%>
<%@page import="java.util.Map"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ServerConfiguration"%>
<%@page import="java.text.DateFormat"%>
<%@page import="java.text.SimpleDateFormat"%>
<%@page import="java.util.Locale"%>
<%@page import="java.util.Date"%>
<jsp:useBean id="MonitorController" scope="session"
	class="org.objectweb.petals.tools.webadmin.controller.MonitorController"></jsp:useBean>
<div id="utils">
	<a href="#" onclick="expandAll('msg_exch');return false;" title="Expand All"><img src="img/plus.png" alt="Expand All"/></a>
	<a href="#" onclick="collapseAll('msg_exch');return false;" title="Collapse All"><img src="img/minus.png" alt="Collapse All"/></a>
</div>
<h2>Exchanges since monitoring started</h2>
<div id="msg_exch">
<%
//object for dates formating
DateFormat df = new SimpleDateFormat("EEE. dd MMM. yyyy, HH:mm:ss.SSS", Locale.ENGLISH);

//RETRIEVING EXCHANGES
Map<String, ExchangesList> stored_exchanges = null;
if (session.getAttribute("stored_exchanges") != null)
{
	stored_exchanges = (Map<String, ExchangesList>) session.getAttribute("stored_exchanges");
}

//RETRIEVING SERVER'S INFO
ServerConfiguration serverConf=null;
//getting current server configuration
if (session.getAttribute("currentServerConf")!=null)
{
	serverConf = (ServerConfiguration) session.getAttribute("currentServerConf");
}

//RETRIEVING COMPONENT NAME
String compo=null;
if (session.getAttribute("currentComponent")!=null)
{
	compo=session.getAttribute("currentComponent").toString();
}


if (stored_exchanges!=null && serverConf!=null && compo!=null)
{
	ExchangesList componentExch = MonitorController.getMsgByComponent(stored_exchanges.get(serverConf.getName()),compo);
	
	int num_id=1;
	if (componentExch!=null && componentExch.size() > 0)
	{
		int totalCaps=0;
		for (MessageExchange currentExch : componentExch)
		{
			//reading exchange id in first message
			Message firstCap = currentExch.get(0);
			String id = firstCap.getId();
			String html_id="datas_"+id;
			String html_buffer=new String();
			int nbCaps = 0;
			
			//indicates if exchange must be shown
			boolean showExchange = false;
			//indicates if exchange has error messages
			boolean hasErrors = false;
			
			for (Message capture : currentExch)
			{
				if (capture.getComponent().equals(compo))
				{
					//message corresponds to asked component -> must be shown 
					//-> adding his html code to buffer to be displayed in exchange
					showExchange=true;
	
					String status = capture.get("status").toString();
					String list_id = new String("ul_"+num_id);
					html_buffer+="<ul id=\""+list_id+"\" class=\""+status+"\">\n";
					html_buffer+="<li><strong>Date :</strong> "+df.format(new Date(capture.getTime()))+" <em>(timestamp "+capture.get("time")+")</em></li>\n";
					html_buffer+="<li><strong>Component :</strong> "+capture.getComponent()+"</li>\n";
					html_buffer+="<li><strong>Role :</strong> "+capture.getRole()+"</li>\n";
					html_buffer+="<li><strong>Type :</strong> "+capture.getType()+"</li>\n";
					html_buffer+="<li><strong>Status :</strong> "+status+"</li>\n";
					html_buffer+="</ul>";
					num_id++;
					nbCaps++;
					totalCaps++;
					if (status.equals("error"))
					{
						hasErrors = true;
					}
				}
			}
			//exchange must be shown -> writing his code with buffer
			if (showExchange)
			{
				String html_class = new String();
				if (hasErrors)
				{
					html_class="error";
				}
				%>
				<h3 id="h3_<%=html_id%>" class="<%=html_class%>">
				<a id="a_<%=html_id%>" class="<%=html_class%>" href="#" 
					onclick="showHide('<%=html_id%>');return false;" 
					title="View <%=id%> datas">
				<img id="img_<%=html_id%>" src="img/plus.png" 
					alt="expand datas" class="expand_ico"/>
				Exch. #<%=id%> (<%=nbCaps%> messages)</a></h3>
				<div id="<%=html_id%>" style="display:none;">
				<%=html_buffer%>
				</div>
				<%
			}
		}
		%>
		</div>
		<p>
		Total exchanges : <%=componentExch.size()%><br />
		Total messages : <%=totalCaps%><br />
		</p>
	<%
	}
	else
	{
		out.print("no message found");
	}
}
%>