<!--
/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -
 * $Id: network.jsp msauvage $
 * -
*/
-->
<%@ page language="java" contentType="text/html; charset=UTF-8"
    pageEncoding="UTF-8" session="true"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Map"%>
<%@page import="java.util.ArrayList"%>
<%@page import="org.objectweb.petals.tools.webadmin.util.JBIEntity"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ServerConfiguration"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.ExchangesList"%>
<%@page import="org.objectweb.petals.tools.webadmin.Object.MessageExchange"%>
<jsp:useBean id="MonitorController" scope="session"
	class="org.objectweb.petals.tools.webadmin.controller.MonitorController"></jsp:useBean>
<%
try {
List<ServerConfiguration> serversList = MonitorController.getAllServers();
List<ServerConfiguration> startedServers = new ArrayList<ServerConfiguration>();
List<ServerConfiguration> stoppedServers = new ArrayList<ServerConfiguration>();
//sort of started/stopped servers
if (serversList!=null && serversList.size()>0)
{
	for (ServerConfiguration currentServer : serversList)
	{
		//recreate started servers list and create stopped servers list
		if(currentServer.getState().equals("started"))
		{
			startedServers.add(currentServer);
		}
		else
		{
			stoppedServers.add(currentServer);
		}
	}
	//reloading menu
	%>
		<script type="text/javascript">
		openPage('menu.jsp','menu');
		</script>
	<%
}
%>

<h1>Servers Informations</h1>
<div id="startedServers">
<h2>Started Servers</h2>
<!-- global monitoring links -->
<ul id="actions-list" class="invisible">
	<li><a href="#" onclick="setInnerHTML(document.getElementById('actions'),getFileContent('startstop.jsp?serv=all&action=start'));return false;" title="Start monitoring all servers"><img src="img/start.png" alt="Start"/>Start monitoring all servers</a></li>
	<li><a href="#" onclick="setInnerHTML(document.getElementById('actions'),getFileContent('startstop.jsp?serv=all&action=stop'));return false;" title="Stop monitoring all servers"><img src="img/stop.png" alt="Stop"/>Stop monitoring all servers</a></li>
</ul>
<%
if(startedServers!=null && startedServers.size()>0)
{
	//display of started servers informations
	for (ServerConfiguration currentServer : startedServers)
	{
		String serverName = currentServer.get("name");
		%>
		<div id="server_"+serverName+"">
		<h3>Server <%=serverName%></h3>
		<div id="info_server_ <%=serverName%>" class="infos-servers">
		<h4 style="margin:10px;">Server Informations :</h4>
		<ul style="margin:0 10px 10px 10px;">
		<li>IP :  <%=currentServer.getHost()%></li>
		<li>jmxPort : <%=currentServer.getJmxPort()%></li>
		</ul>
		</div>
		<div id="compo_server_<% out.print(serverName); %>" class="components">
		<h4>Components :</h4>
		<%
		//listing of components started on the server
		Map<String, JBIEntity> serverComponents = MonitorController.listComponents(currentServer.getConnection(),"ALL");
		if (serverComponents.size()>0)
		{
			%>
			<ul>
			<%
			for (String key : serverComponents.keySet())
			{
				JBIEntity currentComponent = serverComponents.get(key);
				%>
				<li><%=currentComponent.getName()%> (<%=currentComponent.getType()%>)</li>
				<%
			}
			%>
			</ul>
			<%
		}
		else
		{
			%>
			<p>no component available on this server</p>
			<%
		}
		%>
		</div>
		<div id="msg_server_<% out.print(serverName); %>" class="msg-infos">
		<h4>Messages on the Server :</h4>
		<%
		//display sumary informations on exchanges and messages number
		//ExchangesList serverExch = MonitorController.getExchanges(currentServer.getConnection(),0L);
		ExchangesList serverExch = ((Map<String, ExchangesList>) session.getAttribute("stored_exchanges")).get(serverName);
		int nbMsgs=0;
		int nbExch=0;
		if (serverExch != null && serverExch.size()>0)
		{
			//counting exchanges
			nbExch=serverExch.size();
			//counting messages of each exchange
			for (MessageExchange currentExch : serverExch)
			{
				nbMsgs+=currentExch.size();
			}
		}
		%>
		<ul>
			<li>Exchanges : <%=nbExch%></li>
			<li>Messages : <%=nbMsgs%></li>
		</ul>
		</div>
		<div id="monitor_server_<%=serverName%>" class="monitor">
		<h4>Monitor the Server :</h4>
		<%
		//getting actual monitoring status
		String monitoringStatus = MonitorController.getAttribute(currentServer.getConnection(),"Monitoring");
		if (monitoringStatus.equals("true"))
			monitoringStatus="started";
		else
			monitoringStatus="stopped";
		%>
		<!-- individual server's monitoring links -->
		<ul class="invisible">
			<li><img src="img/info.png" alt="Status"/>Monitoring status : <span id="<%=serverName%>_monitor_status"><%=monitoringStatus%></span></li>
			<li><a href="#" onclick="setInnerHTML(document.getElementById('actions'),getFileContent('startstop.jsp?serv=<%=serverName%>&action=start'));return false;" title="Start monitoring"><img src="img/start.png" alt="Start"/>Start monitoring Server <%=serverName%></a></li>
			<li><a href="#" onclick="setInnerHTML(document.getElementById('actions'),getFileContent('startstop.jsp?serv=<%=serverName%>&action=stop'));return false;" title="Stop monitoring"><img src="img/stop.png" alt="Stop"/>Stop monitoring Server <%=serverName%></a></li>
		</ul>
		</div>
		</div>
		<%
	}
}
else
{
	%>
	<p>no started server</p>
	<%
}
%>
</div>
<div id="stoppedServers">
<h2>Stopped Servers</h2>
<%
//display of sumary informations of stopped server's known
if(stoppedServers!=null && stoppedServers.size()>0)
{
	for (ServerConfiguration currentServer : stoppedServers)
	{
%>
		<h3>Server <%=currentServer.getName()%></h3>
		<ul>
		<li>IP : <%=currentServer.getHost()%></li>
		<li>jmxPort : <%=currentServer.getJmxPort()%></li>
		</ul>
		<%
	}
}
else
{
	%>
	<p>no stopped server known</p>
	<%
}
%>
</div>
<%
}
catch (Exception e)
{
	%>
	<h1>Connection Error</h1>
	<p>Cannot connect to server<br />
	Maybe session is down, try to <a href="quit.jsp" title="Restart PEtALS Admin">reconnect</a>.</p>
	<%
	throw new Exception(e);
}
%>